/*
 * wallet.c
 *
 * Copyright (C) 2008 BLADOX, s.r.o.
 *
 */

/*
TODO:
- rename 'credit' -> 'balance'
- about
*/

#include <config.h>
#include <turbo/turbo.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>


/* *INDENT-OFF* */

lc_char PROGMEM lc_Wallet[]={ 
	LC_EN("Wallet")
	LC_END
};

lc_char PROGMEM lc_Set_Limit[]={ 
	LC_EN("Set Limit")
	LC_END 
};

lc_char PROGMEM lc_Enter_Limit[]={ 
	LC_EN("Limit: ")
	LC_END 
};

lc_char PROGMEM lc_Set_Credit[]={ 
	LC_EN("Top Up")
	LC_END 
};

lc_char PROGMEM lc_Enter_Credit[]={ 
	LC_EN("Amount: ")
	LC_END 
};

lc_char PROGMEM lc_Lock[]={ 
	LC_EN("Lock")
	LC_END
};

lc_char PROGMEM lc_View[]={ 
	LC_EN("View")
	LC_END
};

lc_char PROGMEM lc_Enter_PIN[]={
	LC_EN("Enter PIN:")
	LC_END
};

lc_char PROGMEM lc_Error_Wrong_PIN[]={
	LC_EN("Error: Wrong PIN")
	LC_END
};

lc_char PROGMEM lc_Error_No_Wallet_App[]={
	LC_EN("Error: No Wallet Application Installed")
	LC_END
};

lc_char PROGMEM lc_Balance[]={ 
	LC_EN("Balance: ")
	LC_END
};

lc_char PROGMEM lc_Limit[]={ 
	LC_EN("Limit: ")
	LC_END
};

lc_char PROGMEM lc_Last_Amount[]={ 
	LC_EN("Last: ")
	LC_END
};

lc_char PROGMEM lc_Last_Merchant[]={ 
	LC_EN("Merchant: ")
	LC_END
};


/* *INDENT-ON* */

#define MIN_PIN_LEN	8
#define MAX_PIN_LEN	8

typedef struct _Glob_mem
{
  u8 pin[MAX_PIN_LEN];
  u8 pin_len;
}
Glob_mem;

Glob_mem *glob_mem;

u8 PROGMEM t_apdu_select[] =
  { 0x00, 0xA4, 0x04, 0x00, 0x0A, 0xA0, 0x00, 0x00, 0x00, 0x62, 0x03, 0x01,
0x0c, 0x01, 0x01, 0x00 };
u8 PROGMEM t_apdu_verify[] = { 0x80, 0x20, 0x00, 0x00, 0x04 };

  //{ 0x80, 0x20, 0x00, 0x00, 0x04, 0x12, 0x34, 0x56, 0x78 };
u8 PROGMEM t_apdu_set_credit[] = { 0x80, 0x30, 0x00, 0x00, 0x01 };
u8 PROGMEM t_apdu_lock[] = { 0x80, 0x51, 0x00, 0x00, 0x00 };
u8 PROGMEM t_apdu_unlock[] = { 0x80, 0x52, 0x00, 0x00, 0x00 };
u8 PROGMEM t_apdu_set_limit[] = { 0x80, 0x53, 0x00, 0x00, 0x01 };
u8 PROGMEM t_apdu_view[] = { 0x80, 0x54, 0x00, 0x00, 0x00 };

#define DEF_ERR_NO		0x00
#define DEF_ERR_NO_APP		0x01
#define DEF_ERR_WRONG_PIN	0x02

u8 select_wallet ()
{
  u8 *a = buf_A ();
  u8 i, j;
  u16 ret;

  twin_on (NULL);

// select wallet app
  memcpy (a, t_apdu_select, sizeof (t_apdu_select));
  j = twin_t1_apdu (sizeof (t_apdu_select), a);
  ret = a[3];
  ret <<= 8;
  ret |= a[4];
  if (ret != 0x9000)
    return DEF_ERR_NO_APP;

// verify pin
  memcpy (a, t_apdu_verify, sizeof (t_apdu_verify));
  j = glob_mem->pin_len / 2;
  for (i = 0; i < j; i++)
    a[5 + i] = (glob_mem->pin[i * 2] << 4) | glob_mem->pin[i * 2 + 1];
  j += sizeof (t_apdu_verify);
  j = twin_t1_apdu (j, a);
  ret = a[3];
  ret <<= 8;
  ret |= a[4];
  if (ret != 0x9000)
    return DEF_ERR_WRONG_PIN;

// unlock
  memcpy (a, t_apdu_unlock, sizeof (t_apdu_unlock));
  j = twin_t1_apdu (sizeof (t_apdu_unlock), a);

  return DEF_ERR_NO;
}

u8 wallet_view (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 i, j;
    u8 *buf = buf_B ();
    u8 *a = buf_A ();
    u8 *r = buf;
    u16 balance;
    u16 limit;
    u16 amount;

    select_wallet ();

// view
    memcpy (a, t_apdu_view, sizeof (t_apdu_view));
    j = twin_t1_apdu (sizeof (t_apdu_view), a);

    twin_off ();

#define D_OFF	3

    balance = a[D_OFF];
    balance <<= 8;
    balance |= a[D_OFF + 1];

    limit = a[D_OFF + 2];
    limit <<= 8;
    limit |= a[D_OFF + 3];

    amount = a[D_OFF + 4];
    amount <<= 8;
    amount |= a[D_OFF + 5];

    r = sprints (r, locale (lc_Balance));
    r = sprinti (r, balance);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_Limit));
    r = sprinti (r, limit);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_Last_Amount));
    r = sprinti (r, amount);
    r = sprintc (r, '\n');

    j = a[D_OFF + 6];
    r = sprints (r, locale (lc_Last_Merchant));
    for (i = 0; i < j; i++)
      r = sprintc (r, a[D_OFF + 7 + i]);
    r = sprintc (r, '\0');

    i = display_text (buf, NULL);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }

  return APP_OK;
}

u8 wallet_set_limit (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 i;
    u8 *res;
    u16 ret;

    res = get_input (locale (lc_Enter_Limit), 1, 3, NULL, Q_GET_INPUT_DIGITS);
    if (res == NULL)
      return APP_BACK;
    if (res == ENULL)
      return APP_END;

    res[res[0] + 1] = '\0';
    ret = atoi (&res[2]);

    select_wallet ();

// set limit
    memcpy (buf, t_apdu_set_limit, sizeof (t_apdu_set_limit));
    buf[sizeof (t_apdu_set_limit)] = ret;
    twin_t1_apdu (sizeof (t_apdu_set_limit) + 1, buf);

    twin_off ();

    return APP_BACK;
  }
  return APP_OK;
}

u8 wallet_set_credit (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 i;
    u8 *res;
    u16 ret;

    res =
      get_input (locale (lc_Enter_Credit), 1, 3, NULL, Q_GET_INPUT_DIGITS);
    if (res == NULL)
      return APP_BACK;
    if (res == ENULL)
      return APP_END;

    res[res[0] + 1] = '\0';
    ret = atoi (&res[2]);

    select_wallet ();

// set credit
    memcpy (buf, t_apdu_set_credit, sizeof (t_apdu_set_credit));
    buf[sizeof (t_apdu_set_credit)] = ret;
    twin_t1_apdu (sizeof (t_apdu_set_credit) + 1, buf);

    twin_off ();

    return APP_BACK;
  }
  return APP_OK;
}

SNodeP wallet_n = { lc_Wallet, NULL };
SNodeP wallet_n_view = { lc_View, wallet_view };
SNodeP wallet_n_set_limit = { lc_Set_Limit, wallet_set_limit };
SNodeP wallet_n_set_credit = { lc_Set_Credit, wallet_set_credit };

/* *INDENT-OFF* */

SEdgeP wallet_edges_p[] = {
  {&wallet_n, &wallet_n_view},
  {&wallet_n, &wallet_n_set_limit},
  {&wallet_n, &wallet_n_set_credit},
  NULL
};

/* *INDENT-ON* */

void wallet (void *x)
{
  SCtx *c;
  u8 i;
  u8 *res;
  u8 err = NO_ERROR;
  u8 *buf = buf_B ();

  glob_mem = NULL;

  res =
    get_input (locale (lc_Enter_PIN), MIN_PIN_LEN, MAX_PIN_LEN, NULL,
	       Q_GET_INPUT_DIGITS);
  if (res == NULL || res == ENULL)
    goto X_ERR;

  glob_mem = malloc (sizeof (Glob_mem));
  if (glob_mem == NULL)
  {
    err = ERR_NO_RAM;
    goto X_ERR;
  }

  glob_mem->pin_len = res[0];
  for (i = 0; i < res[0] - 1; i++)
    glob_mem->pin[i] = res[2 + i] - '0';

  i = select_wallet ();
  twin_off ();
  if (i != DEF_ERR_NO)
  {
    if (i == DEF_ERR_WRONG_PIN)
      display_text (locale (lc_Error_Wrong_PIN), NULL);
    else
      display_text (locale (lc_Error_No_Wallet_App), NULL);

    goto X_ERR;
  }

  c = spider_init ();
  if (c != NULL)
  {
    c->n = &wallet_n;
    c->eP = &wallet_edges_p;

    spider (c);
  }
  else
    err = ERR_NO_RAM;

  select_wallet ();
// lock
  memcpy (buf, t_apdu_lock, sizeof (t_apdu_lock));
  twin_t1_apdu (sizeof (t_apdu_lock), buf);
  twin_off ();

X_ERR:
  for (i = 0; i < MAX_PIN_LEN; i++)
    glob_mem->pin[i] = 0xff;
  glob_mem->pin_len = 0xff;
  if (err != NO_ERROR)
    perror (err);
  free (glob_mem);
  glob_mem = NULL;
}

u8 PROGMEM t_BLADOX[] = "BLADOX";

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_INSERT_MENU:
      set_menu_alpha (t_BLADOX);
      insert_menu (locale (lc_Wallet));
      break;
    case ACTION_MENU_SELECTION:
      stk_thread (wallet, NULL);
      break;
    default:
      break;
  }
}
